﻿//////////////////////////////////////////////
// BufferWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::nkMemoryWrap
{
	class DLL_ASTRAEUS_EXPORT BufferWrapper final
	{
		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Constructor, destructor
			static nkScripts::OutputValue constructor (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue constructorFromString (const nkScripts::DataStack& stack) ;
			static void destructor (void* toDestroy) ;
			// Getters
			static nkScripts::OutputValue getData (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getSize (const nkScripts::DataStack& stack) ;
	} ;
}