﻿//////////////////////////////////////////////
// BufferManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

#include "../Utils/Manager.h"

#include "Buffer.h"

// nkCommon
#include <nilkinsCommon/Patterns/MaybeSingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------

namespace nkGraphics
{	
	class DLL_GRAPHICS_EXPORT BufferManager : public Manager<Buffer>, public nkCommon::MaybeSingletonClass<BufferManager>
	{
		private :

			// Constructors
			BufferManager (bool isSingleton) noexcept ;
			BufferManager (System* system) noexcept ;

		private :

			friend class nkCommon::MaybeSingletonClass<BufferManager> ;
			friend class System ;
	} ;
}