﻿//////////////////////////////////////////////
// MonoMaterialPass.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Shader ;
}

/// Includes ---------------------------------

// nkGraphics
#include "RenderScenePass.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT MonoMaterialPass : public RenderScenePass
	{		
		public :			

			// Getters
			Shader* getShader () const ;

			// Setters
			virtual void setShader (Shader* shade) ;

			// Import / Export
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;

		protected :

			// Constructor
			MonoMaterialPass (System* system) noexcept ;

		protected :		
		
			// Attributes
			Shader* _shader ;
	} ;
}